# shout2send

shout2send pushes a media stream to an Icecast server

## Example launch line

     gst-launch-1.0 uridecodebin uri=file:///path/to/audiofile ! audioconvert ! vorbisenc ! oggmux ! shout2send mount=/stream.ogg port=8000 username=source password=somepassword ip=server_IP_address_or_hostname

This pipeline demuxes, decodes, re-encodes and re-muxes an audio media file into oggvorbis and sends the resulting stream to an Icecast server. Properties mount, port, username and password are all server-config dependent.

## Hierarchy

    GObject
        ╰──GInitiallyUnowned
            ╰──GstObject
                ╰──GstElement
                    ╰──GstBaseSink
                        ╰──shout2send

## Implemented interfaces

    GstTagSetter

## Factory details

Authors: – Wim Taymans , Pedro Corte-Real , Zaheer Abbas Merali

Classification: – `Sink/Network`

Rank – none

Plugin – shout2

Package – GStreamer Good Plug-ins

## Pad Templates

### `sink`

    application/ogg:
    audio/ogg:
    video/ogg:
    audio/mpeg:
        mpegversion: 1
              layer: [ 1, 3 ]
    video/webm:
    audio/webm:

Presence – always

Direction – sink

Object type – GstPad

## Signals

### connection-problem

    connection_problem_callback (GstElement * param_0,
                                 gint arg0,
                                 gpointer udata)

    def connection_problem_callback (param_0, arg0, udata):
        #python callback for the 'connection-problem' signal

    function connection_problem_callback(param_0: GstElement * param_0, arg0: gint arg0, udata: gpointer udata): {
        // javascript callback for the 'connection-problem' signal
    }

Parameters:

`param_0` –
No description available
`arg0` –
No description available
`udata` –
No description available

Flags: Run Cleanup

## Properties

### description

    “description” gchararray

description

Flags : Read / Write

### genre

    “genre” gchararray

genre

Flags : Read / Write

### ip

    “ip” gchararray

IP address or hostname

Flags : Read / Write

Default value : 127.0.0.1

### mount

    “mount” gchararray

mount

Flags : Read / Write

### password

    “password” gchararray

password

Flags : Read / Write

Default value : hackme

### port

    “port” gint

port

Flags : Read / Write

Default value : 8000

### protocol

    “protocol” GstShout2SendProtocol *

Connection Protocol to use

Flags : Read / Write

Default value : http (3)

### public

    “public” gboolean

If the stream should be listed on the server's stream directory

Flags : Read / Write

Default value : false

### send-title-info

    “send-title-info” gboolean

Update stream metadata with song title and artist information

Flags : Read / Write

Default value : true

Since : 1.22

### streamname

    “streamname” gchararray

name of the stream

Flags : Read / Write

### timeout

    “timeout” guint

Max amount of time to wait for network activity, in milliseconds

Flags : Read / Write

Default value : 10000

### url

    “url” gchararray

the stream's homepage URL

Flags : Read / Write

### user-agent

    “user-agent” gchararray

User agent of the source

If the string contains `{VERSION}` that will be replaced with the GStreamer version at runtime (since GStreamer 1.24).

Flags : Read / Write

Default value : GStreamer {VERSION}

Since : 1.22

### username

    “username” gchararray

username

Flags : Read / Write

Default value : source

## Named constants

### GstShout2SendProtocol

#### Members

`xaudiocast` (1) – Xaudiocast Protocol (icecast 1.3.x)
`icy` (2) – Icy Protocol (ShoutCast)
`http` (3) – Http Protocol (icecast 2.x)

The results of the search are